<template>
    <div>
        <v-card
            class="mx-auto sheet"
            max-width="800"
            color="#FFF9C4"
            @drop.prevent="fileDropped"
            @dragenter.prevent="dragover = true"
            @dragleave.prevent="dragover = false"
            @dragover.prevent="dragover = true"
            flat
        >
            <v-icon class="drop-icon" v-if="dragover" color="yellow darken-2" size="50" style="pointer-events: none;"
                >mdi-book-plus</v-icon
            >
            <v-file-input
                :key="uploaderKey"
                ref="uploader"
                class="d-none"
                accept="image/*"
                @change="fileUpload"
                multiple
            ></v-file-input>
            <div class="drop-zone">
                <v-slide-group ref="slider" show-arrows center-active>
                    <v-slide-item v-for="(file, key) in filesDish" :key="key" v-slot:default="{ active }">
                        <v-card
                            :ref="'preview' + key"
                            :color="active ? undefined : 'grey lighten-1'"
                            class="ma-3 preview"
                            height="80%"
                            style="height: 13vh;"
                            width="70"
                            :img="previewImg(file, key)"
                            @click="$refs['uploader' + key][0].$refs.input.click()"
                            @mouseover.native="toggle = key"
                            @mouseleave.native="toggle = null"
                        >
                            <v-btn class="close" @click="fileRemove(file, key)" height="20" width="20" fab
                                ><span>&times;</span></v-btn
                            >
                            <v-file-input
                                :ref="'uploader' + key"
                                class="d-none"
                                accept="image/*"
                                :value="file"
                                @change="fileChange($event, key)"
                            ></v-file-input>
                        </v-card>
                    </v-slide-item>
                </v-slide-group>
            </div>
        </v-card>
        <v-btn class="add" width="40%" style="float: right;" @click="$refs.uploader.$refs.input.click()" depressed
            >+ Agregar imagen/es</v-btn
        >
    </div>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from 'vue-property-decorator';
import { getFile } from '@/services/StorageService';

interface SlideGroup {
    scrollOffset: number;
    items: Card[];
}

interface Card {
    style: {
        backgroundImage: string;
    };
}

@Component
export default class GalleryDragAndDrop extends Vue {
    @Prop({ default: () => [] })
    files!: string[];
    @Prop({ default: () => 1 })
    max!: number;
    @Prop({ default: () => 1 })
    resetOffset!: number;
    originalFilesPreview: string[] = [];
    originalFiles: File[] = [];
    newFiles: File[] = [];
    uploaderKey = 0;
    dragover = false;
    toggle = null;

    fileDropped(dragevent: DragEvent) {
        if (dragevent.dataTransfer) {
            this.newFiles.push(...dragevent.dataTransfer.files);
            this.$emit('filesChanged', this.newFiles);
            this.dragover = false;
        }
    }

    fileUpload(files: File[]) {
        this.newFiles.push(...files);
        this.$emit('filesChanged', this.newFiles);
        this.uploaderKey++;
    }

    fileChange(file: File, key: number) {
        this.newFiles.splice(key, 1, file);
        this.$emit('filesChanged', this.newFiles);
    }

    fileRemove(file: File, index: number) {
        this.newFiles.splice(this.newFiles.indexOf(file), 1);
        this.originalFilesPreview.splice(index, 1);
        this.$emit('filesChanged', this.newFiles);
        if (this.newFiles.length < this.resetOffset) {
            this.resetSlider();
        }
    }

    resetSlider() {
        ((this.$refs.slider as unknown) as SlideGroup).scrollOffset = 0;
    }

    previewImg(file: File, key: number) {
        if (file.size !== 0) {
            return URL.createObjectURL(file);
        } else {
            return this.originalFilesPreview[key];
        }
    }

    async getFilesPreview() {
        return Promise.all(this.files.map(async file => (await getFile(file)) || ''));
    }

    @Watch('files')
    async onOriginalFilesChanged() {
        this.newFiles = [];
        if (this.files) {
            this.originalFiles = this.files.map(file => new File([], file, { type: 'image/png' }));
            this.originalFilesPreview = await this.getFilesPreview();
            this.newFiles = this.originalFiles;
        }
    }

    get filesDish() {
        return this.newFiles;
    }

    async mounted() {
        await this.onOriginalFilesChanged();
    }
}
</script>
<style type="text/css">
.sheet {
    border: 2px dashed;
    border-color: #f0c74b !important;
    height: 17vh;
}
.drop-zone {
    display: flex;
    align-items: center;
    position: relative;
}
.drop-icon {
    width: 100%;
    height: 100%;
    background: rgba(253, 185, 71, 0.6);
    position: absolute !important;
    z-index: 1;
    transition: all 0.5s;
    -webkit-transition: all 0.5s;
}
.edit-icon {
    position: relative;
    top: calc(50% - 10px);
}
.close {
    position: absolute;
    background: #fff;
    right: -10px;
}
.close span {
    color: #000;
    font-weight: 700;
    font-size: 20px;
}
.preview {
    background-position: center;
    background-size: contain;
}
</style>
